#include "config.h"

#define HALL_SENSOR_PIN 10
#define BATTERY_PIN 9

void connect_AIO() {
//  Serial.println("Connecting to Adafruit IO...");
  io.connect();
  // wait for a connection
  while (io.status() < AIO_CONNECTED) {
//    Serial.print(".");
    delay(100);
  }
  // we are connected
//  Serial.println();
//  Serial.println(io.statusText());
}

void door_opened(){
  if (io.status() < AIO_CONNECTED) connect_AIO();
  AdafruitIO_Feed *mailbox = io.feed("mailbox");
//  Serial.println("Sending door open...");
  mailbox->save(1);
  io.run();
}

void door_closed(){
  if (io.status() < AIO_CONNECTED) connect_AIO();
  AdafruitIO_Feed *mailbox = io.feed("mailbox");
//  Serial.println("Sending door closed...");
  mailbox->save(0);
  io.run();
}

void battery_level() {
  int level = analogRead(BATTERY_PIN);
  // 4.7 to 6.3 V for four AAA batteries
  // 100k and 1M resistor divider
  int percent = map(level, 95, 127, 0, 100);
  if (percent>100) {
    percent = 100;
  } else if (percent<0) {
    percent = 0;
  }
//  Serial.print("Battery level: "); Serial.print(level); Serial.print(", "); Serial.print(percent); Serial.println("%");
  // send battery level to AdafruitIO
  if (io.status() < AIO_CONNECTED) connect_AIO();
  AdafruitIO_Feed *battery = io.feed("battery");
  battery->save(percent);
  io.run();
}

void setup() {
  ESP.eraseConfig();
//  Serial.begin(115200);
  pinMode(HALL_SENSOR_PIN,INPUT);
  if (!digitalRead(HALL_SENSOR_PIN)) {
    door_opened();
    while (!digitalRead(HALL_SENSOR_PIN)) delay(200);
    door_closed();
  }
  battery_level();
  ESP.deepSleep(0);
}

void loop() {
}
